PROGRAM coindexing
  ! Simple program illustrating coindexing across teams and
  ! team allocation of coarrays
  USE, INTRINSIC :: iso_fortran_env
  IMPLICIT NONE

  INTEGER, PARAMETER :: max_team_size = 3
  INTEGER :: id[*], img, ifsize, it, maxid
!  INTEGER :: iv ! workaround
  TYPE(team_type) :: groups, init
  TYPE(event_type) :: serialize[*]
  INTEGER, ALLOCATABLE :: i_init(:)[:], i_team(:)[:]


  id = (this_image() - 1) / max_team_size + 1
  ! images 1-3 constitute team 1, 4-6 constitute team 2 etc.
  img = mod(this_image() - 1, max_team_size) + 1

  init = get_team()  ! initial team
  
  FORM TEAM(id, groups, NEW_INDEX=img)

  maxid = 0
  DO img = 1, num_images()
     maxid = max(id[img], maxid)
  END DO
  
  ifsize = 1
  ALLOCATE(i_init(ifsize)[*], source=[this_image()])
  ! synchronizes against references to i_init inside the 

  CHANGE TEAM (groups)
    IF (team_number() == 1 .AND. this_image() == 1) THEN
       WRITE(*,FMT='("i_init from last image of each team:")') 
       DO it = 1, maxid
! workaround
!         iv = i_init(1)[ num_images(it),TEAM_NUMBER=it ]
!         WRITE(*,FMT='(i0)') iv
         WRITE(*,FMT='(i0)') &
                 i_init(1)[ num_images(it),TEAM_NUMBER=it ] 
       END DO
       WRITE(*,FMT='("i_init from last image of initial team:")') 
! workaround
!       iv = i_init(1)[ num_images(init),TEAM=init ]
!       WRITE(*,FMT='(i0)') iv
       WRITE(*,FMT='(i0)') &
            i_init(1)[ num_images(init),TEAM=init ] 
    END IF
    SYNC TEAM (init)
    ifsize = team_number()
    ALLOCATE(i_team(ifsize)[*])
    IF (this_image() == 1) THEN
       IF (team_number() > 1) &
            EVENT WAIT ( serialize )
       WRITE(*,FMT='("Size of i_team on team ",i0, " is ",i0)') &
            team_number(), size(i_team)
       IF (team_number() < maxid) &
            EVENT POST ( serialize[1, TEAM_NUMBER=team_number()+1] )
    END IF
  END TEAM
  SYNC ALL
  IF (this_image() == 1) THEN
     WRITE(*,FMT='("Allocation status of i_init and i_team: ",2L2)') &
          allocated(i_init), allocated(i_team)
  END IF
END PROGRAM coindexing
