PROGRAM even_odd
! Simple teams example:
! Split into two teams corresponding to even and odd images
! If both teams write numbers in ascending order, the implementation
! has decided to handle image number assignment thusly.
!
  USE, INTRINSIC :: iso_fortran_env
  IMPLICIT NONE

  INTEGER :: index[*]
  TYPE(team_type) :: team_even_odd
  INTEGER :: id, img
  
  index = this_image()
  id = 2 - mod(index, 2) ! 1 corresponds to odd images, 2 to even images  
  
  FORM TEAM (id, team_even_odd)

  CHANGE TEAM (team_even_odd)
    IF (team_number() == 1 .AND. this_image() == 1) THEN
       WRITE(*,*) 'Writing index from images of team 1'
       DO img=1, num_images()
          WRITE(*,FMT='(I4)') index[img]
       END DO
    END IF
    SYNC TEAM (get_team(INITIAL_TEAM))
    IF (team_number() == 2 .AND. this_image() == 1) THEN
       WRITE(*,*) 'Writing index from images of team 2'
       DO img=1, num_images()
          WRITE(*,FMT='(I4)') index[img]
       END DO
    END IF
  END TEAM
END PROGRAM even_odd
